Index: trunk/src/VBox/Runtime/common/fs/extvfs.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/fs/extvfs.cpp	(revision 79155)
+++ trunk/src/VBox/Runtime/common/fs/extvfs.cpp	(revision 80585)
@@ -2723,5 +2723,5 @@
         RTListInit(&pThis->LstBlockLru);
 
-        rc = RTVfsFileGetSize(pThis->hVfsBacking, &pThis->cbBacking);
+        rc = RTVfsFileQuerySize(pThis->hVfsBacking, &pThis->cbBacking);
         if (RT_SUCCESS(rc))
         {
Index: trunk/src/VBox/Runtime/common/fs/fatvfs.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/fs/fatvfs.cpp	(revision 79155)
+++ trunk/src/VBox/Runtime/common/fs/fatvfs.cpp	(revision 80585)
@@ -5620,5 +5620,5 @@
      * Get stuff that may fail.
      */
-    int rc = RTVfsFileGetSize(hVfsBacking, &pThis->cbBacking);
+    int rc = RTVfsFileQuerySize(hVfsBacking, &pThis->cbBacking);
     if (RT_FAILURE(rc))
         return rc;
@@ -5816,5 +5816,5 @@
     {
         uint64_t cbFile;
-        rc = RTVfsFileGetSize(hVfsFile, &cbFile);
+        rc = RTVfsFileQuerySize(hVfsFile, &cbFile);
         AssertRCReturn(rc, rc);
         AssertMsgReturn(cbFile > offVol, ("cbFile=%#RX64 offVol=%#RX64\n", cbFile, offVol), VERR_INVALID_PARAMETER);
Index: trunk/src/VBox/Runtime/common/fs/isomaker.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/fs/isomaker.cpp	(revision 79155)
+++ trunk/src/VBox/Runtime/common/fs/isomaker.cpp	(revision 80585)
@@ -6248,5 +6248,5 @@
      */
     uint64_t cbResult = 0;
-    rc = RTVfsFileGetSize(hVfsFile, &cbResult);
+    rc = RTVfsFileQuerySize(hVfsFile, &cbResult);
     if (RT_SUCCESS(rc) && cbResult == pFile->cbData)
     {
Index: trunk/src/VBox/Runtime/common/fs/isomakercmd.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/fs/isomakercmd.cpp	(revision 79155)
+++ trunk/src/VBox/Runtime/common/fs/isomakercmd.cpp	(revision 80585)
@@ -1105,5 +1105,5 @@
      */
     uint64_t cbImage;
-    int rc = RTVfsFileGetSize(hVfsSrcFile, &cbImage);
+    int rc = RTVfsFileQuerySize(hVfsSrcFile, &cbImage);
     if (RT_SUCCESS(rc))
     {
@@ -1160,5 +1160,5 @@
     }
     else
-        rc = rtFsIsoMakerCmdErrorRc(pOpts, rc, "RTVfsFileGetSize failed: %Rrc", rc);
+        rc = rtFsIsoMakerCmdErrorRc(pOpts, rc, "RTVfsFileQuerySize failed: %Rrc", rc);
     return rc;
 }
@@ -3075,5 +3075,5 @@
 
     uint64_t cbFile = 0;
-    rc = RTVfsFileGetSize(hVfsFile, &cbFile);
+    rc = RTVfsFileQuerySize(hVfsFile, &cbFile);
     if (RT_SUCCESS(rc))
     {
@@ -3127,5 +3127,5 @@
     }
     else
-        rtFsIsoMakerCmdErrorRc(pOpts, rc, "%s: RTVfsFileGetSize failed: %Rrc", pszFileSpec, rc);
+        rtFsIsoMakerCmdErrorRc(pOpts, rc, "%s: RTVfsFileQuerySize failed: %Rrc", pszFileSpec, rc);
     RTVfsFileRelease(hVfsFile);
     return rc;
Index: trunk/src/VBox/Runtime/common/fs/isomakerimport.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/fs/isomakerimport.cpp	(revision 79155)
+++ trunk/src/VBox/Runtime/common/fs/isomakerimport.cpp	(revision 80585)
@@ -2521,5 +2521,5 @@
      */
     uint64_t cbSrcFile = 0;
-    int rc = RTVfsFileGetSize(hIsoFile, &cbSrcFile);
+    int rc = RTVfsFileQuerySize(hIsoFile, &cbSrcFile);
     if (RT_SUCCESS(rc))
     {
Index: trunk/src/VBox/Runtime/common/fs/isovfs.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/fs/isovfs.cpp	(revision 79155)
+++ trunk/src/VBox/Runtime/common/fs/isovfs.cpp	(revision 80585)
@@ -5618,5 +5618,5 @@
      * Get stuff that may fail.
      */
-    int rc = RTVfsFileGetSize(hVfsBacking, &pThis->cbBacking);
+    int rc = RTVfsFileQuerySize(hVfsBacking, &pThis->cbBacking);
     if (RT_SUCCESS(rc))
         pThis->cBackingSectors = pThis->cbBacking / pThis->cbSector;
Index: trunk/src/VBox/Runtime/common/fs/ntfsvfs.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/fs/ntfsvfs.cpp	(revision 79155)
+++ trunk/src/VBox/Runtime/common/fs/ntfsvfs.cpp	(revision 80585)
@@ -5536,5 +5536,5 @@
         RTListInit(&pThis->IdxNodeUnusedHead);
 
-        rc = RTVfsFileGetSize(pThis->hVfsBacking, &pThis->cbBacking);
+        rc = RTVfsFileQuerySize(pThis->hVfsBacking, &pThis->cbBacking);
         if (RT_SUCCESS(rc))
         {
Index: trunk/src/VBox/Runtime/common/fs/xfsvfs.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/fs/xfsvfs.cpp	(revision 79155)
+++ trunk/src/VBox/Runtime/common/fs/xfsvfs.cpp	(revision 80585)
@@ -2327,5 +2327,5 @@
         RTListInit(&pThis->LstBlockLru);
 
-        rc = RTVfsFileGetSize(pThis->hVfsBacking, &pThis->cbBacking);
+        rc = RTVfsFileQuerySize(pThis->hVfsBacking, &pThis->cbBacking);
         if (RT_SUCCESS(rc))
         {