Index: trunk/include/VBox/GuestHost/SharedClipboard-win.h
===================================================================
--- trunk/include/VBox/GuestHost/SharedClipboard-win.h	(revision 80663)
+++ trunk/include/VBox/GuestHost/SharedClipboard-win.h	(revision 80664)
@@ -52,22 +52,22 @@
 #endif
 
-#define VBOX_CLIPBOARD_WNDCLASS_NAME         "VBoxSharedClipboardClass"
+#define SHCL_WIN_WNDCLASS_NAME        "VBoxSharedClipboardClass"
 
 /** See: https://docs.microsoft.com/en-us/windows/desktop/dataxchg/html-clipboard-format
  *       Do *not* change the name, as this will break compatbility with other (legacy) applications! */
-#define VBOX_CLIPBOARD_WIN_REGFMT_HTML       "HTML Format"
+#define SHCL_WIN_REGFMT_HTML          "HTML Format"
 
 /** Default timeout (in ms) for passing down messages down the clipboard chain. */
-#define VBOX_CLIPBOARD_CBCHAIN_TIMEOUT_MS   5000
+#define SHCL_WIN_CBCHAIN_TIMEOUT_MS   5000
 
 /** Reports clipboard formats. */
-#define VBOX_CLIPBOARD_WM_REPORT_FORMATS    WM_USER
+#define SHCL_WIN_WM_REPORT_FORMATS    WM_USER
 /** Reads data from the clipboard and sends it to the destination. */
-#define VBOX_CLIPBOARD_WM_READ_DATA         WM_USER + 1
+#define SHCL_WIN_WM_READ_DATA         WM_USER + 1
 #ifdef VBOX_WITH_SHARED_CLIPBOARD_URI_LIST
 /** Starts a reading transfer from the guest. */
-# define VBOX_CLIPBOARD_WM_URI_START_READ   WM_USER + 2
+# define SHCL_WIN_WM_URI_START_READ   WM_USER + 2
 /** Starts a writing transfer to the guest. */
-# define VBOX_CLIPBOARD_WM_URI_START_WRITE  WM_USER + 3
+# define SHCL_WIN_WM_URI_START_WRITE  WM_USER + 3
 #endif
 
@@ -106,9 +106,9 @@
 {
     /** Window handle of our (invisible) clipbaord window. */
-    HWND                        hWnd;
+    HWND               hWnd;
     /** Window handle which is next to us in the clipboard chain. */
-    HWND                        hWndNextInChain;
+    HWND               hWndNextInChain;
     /** Window handle of the clipboard owner *if* we are the owner. */
-    HWND                        hWndClipboardOwnerUs;
+    HWND               hWndClipboardOwnerUs;
     /** Structure for maintaining the new clipboard API. */
     SHCLWINAPINEW      newAPI;
@@ -117,37 +117,37 @@
 } SHCLWINCTX, *PSHCLWINCTX;
 
-int VBoxClipboardWinOpen(HWND hWnd);
-int VBoxClipboardWinClose(void);
-int VBoxClipboardWinClear(void);
-
-int VBoxClipboardWinCheckAndInitNewAPI(PSHCLWINAPINEW pAPI);
-bool VBoxClipboardWinIsNewAPI(PSHCLWINAPINEW pAPI);
-
-int VBoxClipboardWinChainAdd(PSHCLWINCTX pCtx);
-int VBoxClipboardWinChainRemove(PSHCLWINCTX pCtx);
-VOID CALLBACK VBoxClipboardWinChainPingProc(HWND hWnd, UINT uMsg, ULONG_PTR dwData, LRESULT lResult);
-LRESULT VBoxClipboardWinChainPassToNext(PSHCLWINCTX pWinCtx, UINT msg, WPARAM wParam, LPARAM lParam);
-
-SHCLFORMAT VBoxClipboardWinClipboardFormatToVBox(UINT uFormat);
-int VBoxClipboardWinGetFormats(PSHCLWINCTX pCtx, PSHCLFORMATDATA pFormats);
+int SharedClipboardWinOpen(HWND hWnd);
+int SharedClipboardWinClose(void);
+int SharedClipboardWinClear(void);
+
+int SharedClipboardWinCheckAndInitNewAPI(PSHCLWINAPINEW pAPI);
+bool SharedClipboardWinIsNewAPI(PSHCLWINAPINEW pAPI);
+
+int SharedClipboardWinChainAdd(PSHCLWINCTX pCtx);
+int SharedClipboardWinChainRemove(PSHCLWINCTX pCtx);
+VOID CALLBACK SharedClipboardWinChainPingProc(HWND hWnd, UINT uMsg, ULONG_PTR dwData, LRESULT lResult);
+LRESULT SharedClipboardWinChainPassToNext(PSHCLWINCTX pWinCtx, UINT msg, WPARAM wParam, LPARAM lParam);
+
+SHCLFORMAT SharedClipboardWinClipboardFormatToVBox(UINT uFormat);
+int SharedClipboardWinGetFormats(PSHCLWINCTX pCtx, PSHCLFORMATDATA pFormats);
 
 #ifdef VBOX_WITH_SHARED_CLIPBOARD_URI_LIST
-int VBoxClipboardWinDropFilesToStringList(DROPFILES *pDropFiles, char **papszList, uint32_t *pcbList);
-#endif
-
-int VBoxClipboardWinGetCFHTMLHeaderValue(const char *pszSrc, const char *pszOption, uint32_t *puValue);
-bool VBoxClipboardWinIsCFHTML(const char *pszSource);
-int VBoxClipboardWinConvertCFHTMLToMIME(const char *pszSource, const uint32_t cch, char **ppszOutput, uint32_t *pcbOutput);
-int VBoxClipboardWinConvertMIMEToCFHTML(const char *pszSource, size_t cb, char **ppszOutput, uint32_t *pcbOutput);
-
-LRESULT VBoxClipboardWinHandleWMChangeCBChain(PSHCLWINCTX pWinCtx, HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
-int VBoxClipboardWinHandleWMDestroy(PSHCLWINCTX pWinCtx);
-int VBoxClipboardWinHandleWMRenderAllFormats(PSHCLWINCTX pWinCtx, HWND hWnd);
-int VBoxClipboardWinHandleWMTimer(PSHCLWINCTX pWinCtx);
-
-int VBoxClipboardWinAnnounceFormats(PSHCLWINCTX pWinCtx, SHCLFORMATS fFormats);
+int SharedClipboardWinDropFilesToStringList(DROPFILES *pDropFiles, char **papszList, uint32_t *pcbList);
+#endif
+
+int SharedClipboardWinGetCFHTMLHeaderValue(const char *pszSrc, const char *pszOption, uint32_t *puValue);
+bool SharedClipboardWinIsCFHTML(const char *pszSource);
+int SharedClipboardWinConvertCFHTMLToMIME(const char *pszSource, const uint32_t cch, char **ppszOutput, uint32_t *pcbOutput);
+int SharedClipboardWinConvertMIMEToCFHTML(const char *pszSource, size_t cb, char **ppszOutput, uint32_t *pcbOutput);
+
+LRESULT SharedClipboardWinHandleWMChangeCBChain(PSHCLWINCTX pWinCtx, HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
+int SharedClipboardWinHandleWMDestroy(PSHCLWINCTX pWinCtx);
+int SharedClipboardWinHandleWMRenderAllFormats(PSHCLWINCTX pWinCtx, HWND hWnd);
+int SharedClipboardWinHandleWMTimer(PSHCLWINCTX pWinCtx);
+
+int SharedClipboardWinAnnounceFormats(PSHCLWINCTX pWinCtx, SHCLFORMATS fFormats);
 #ifdef VBOX_WITH_SHARED_CLIPBOARD_URI_LIST
-int VBoxClipboardWinURITransferCreate(PSHCLWINCTX pWinCtx, PSHCLURITRANSFER pTransfer);
-void VBoxClipboardWinURITransferDestroy(PSHCLWINCTX pWinCtx, PSHCLURITRANSFER pTransfer);
+int SharedClipboardWinURITransferCreate(PSHCLWINCTX pWinCtx, PSHCLURITRANSFER pTransfer);
+void SharedClipboardWinURITransferDestroy(PSHCLWINCTX pWinCtx, PSHCLURITRANSFER pTransfer);
 #endif
 
@@ -158,5 +158,5 @@
 #  endif
 
-class VBoxClipboardWinDataObject : public IDataObject //, public IDataObjectAsyncCapability
+class SharedClipboardWinDataObject : public IDataObject //, public IDataObjectAsyncCapability
 {
 public:
@@ -170,7 +170,7 @@
 public:
 
-    VBoxClipboardWinDataObject(PSHCLURITRANSFER pTransfer,
-                               LPFORMATETC pFormatEtc = NULL, LPSTGMEDIUM pStgMed = NULL, ULONG cFormats = 0);
-    virtual ~VBoxClipboardWinDataObject(void);
+    SharedClipboardWinDataObject(PSHCLURITRANSFER pTransfer,
+                                 LPFORMATETC pFormatEtc = NULL, LPSTGMEDIUM pStgMed = NULL, ULONG cFormats = 0);
+    virtual ~SharedClipboardWinDataObject(void);
 
 public: /* IUnknown methods. */
@@ -235,5 +235,5 @@
     {
         /** Relative path of the object. */
-        Utf8Str                  strPath;
+        Utf8Str       strPath;
         /** Related (cached) object information. */
         SHCLFSOBJINFO objInfo;
@@ -248,5 +248,5 @@
     LPFORMATETC                 m_pFormatEtc;
     LPSTGMEDIUM                 m_pStgMedium;
-    PSHCLURITRANSFER m_pTransfer;
+    PSHCLURITRANSFER            m_pTransfer;
     IStream                    *m_pStream;
     ULONG                       m_uObjIdx;
@@ -262,10 +262,10 @@
 };
 
-class VBoxClipboardWinEnumFormatEtc : public IEnumFORMATETC
-{
-public:
-
-    VBoxClipboardWinEnumFormatEtc(LPFORMATETC pFormatEtc, ULONG cFormats);
-    virtual ~VBoxClipboardWinEnumFormatEtc(void);
+class SharedClipboardWinEnumFormatEtc : public IEnumFORMATETC
+{
+public:
+
+    SharedClipboardWinEnumFormatEtc(LPFORMATETC pFormatEtc, ULONG cFormats);
+    virtual ~SharedClipboardWinEnumFormatEtc(void);
 
 public: /* IUnknown methods. */
@@ -299,11 +299,11 @@
  * through HGCM. Needed on Windows hosts and guests.
  */
-class VBoxClipboardWinStreamImpl : public IStream
-{
-public:
-
-    VBoxClipboardWinStreamImpl(VBoxClipboardWinDataObject *pParent, PSHCLURITRANSFER pTransfer,
-                               const Utf8Str &strPath, PSHCLFSOBJINFO pObjInfo);
-    virtual ~VBoxClipboardWinStreamImpl(void);
+class SharedClipboardWinStreamImpl : public IStream
+{
+public:
+
+    SharedClipboardWinStreamImpl(SharedClipboardWinDataObject *pParent, PSHCLURITRANSFER pTransfer,
+                                 const Utf8Str &strPath, PSHCLFSOBJINFO pObjInfo);
+    virtual ~SharedClipboardWinStreamImpl(void);
 
 public: /* IUnknown methods. */
@@ -329,20 +329,20 @@
 public: /* Own methods. */
 
-    static HRESULT Create(VBoxClipboardWinDataObject *pParent, PSHCLURITRANSFER pTransfer, const Utf8Str &strPath,
+    static HRESULT Create(SharedClipboardWinDataObject *pParent, PSHCLURITRANSFER pTransfer, const Utf8Str &strPath,
                           PSHCLFSOBJINFO pObjInfo, IStream **ppStream);
 private:
 
     /** Pointer to the parent data object. */
-    VBoxClipboardWinDataObject    *m_pParent;
+    SharedClipboardWinDataObject  *m_pParent;
     /** The stream object's current reference count. */
     LONG                           m_lRefCount;
     /** Pointer to the associated URI transfer. */
-    PSHCLURITRANSFER    m_pURITransfer;
+    PSHCLURITRANSFER               m_pURITransfer;
     /** The object handle to use. */
-    SHCLOBJHANDLE       m_hObj;
+    SHCLOBJHANDLE                  m_hObj;
     /** Object path. */
     Utf8Str                        m_strPath;
     /** (Cached) object information. */
-    SHCLFSOBJINFO       m_objInfo;
+    SHCLFSOBJINFO                  m_objInfo;
     /** Number of bytes already processed. */
     uint64_t                       m_cbProcessed;
@@ -369,5 +369,5 @@
     /** Pointer to data object to use for this transfer.
      *  Can be NULL if not being used. */
-    VBoxClipboardWinDataObject *pDataObj;
+    SharedClipboardWinDataObject *pDataObj;
 };
 # endif /* VBOX_WITH_SHARED_CLIPBOARD_URI_LIST */