Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsDisplay.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsDisplay.cpp	(revision 80668)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsDisplay.cpp	(revision 80669)
@@ -191,6 +191,6 @@
         m_pResolutionHeightSpin->setMinimum(iMinHeight);
         m_pResolutionHeightSpin->setMaximum(iMaxSize);
-        connect(m_pMaxResolutionCombo, SIGNAL(currentIndexChanged(int)),
-                this, SLOT(sltHandleMaximumGuestScreenSizePolicyChange()));
+        connect(m_pMaxResolutionCombo, static_cast<void(QComboBox::*)(int)>(&QComboBox::activated),
+                this, &UIGlobalSettingsDisplay::sltHandleMaximumGuestScreenSizePolicyChange);
     }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsExtension.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsExtension.cpp	(revision 80668)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsExtension.cpp	(revision 80669)
@@ -426,8 +426,8 @@
             m_pPackagesTree->header()->setSectionResizeMode(2, QHeaderView::ResizeToContents);
             m_pPackagesTree->setContextMenuPolicy(Qt::CustomContextMenu);
-            connect(m_pPackagesTree, SIGNAL(currentItemChanged(QTreeWidgetItem *, QTreeWidgetItem *)),
-                    this, SLOT(sltHandleCurrentItemChange(QTreeWidgetItem *)));
-            connect(m_pPackagesTree, SIGNAL(customContextMenuRequested(const QPoint &)),
-                    this, SLOT(sltHandleContextMenuRequest(const QPoint &)));
+            connect(m_pPackagesTree, &QITreeWidget::currentItemChanged,
+                    this, &UIGlobalSettingsExtension::sltHandleCurrentItemChange);
+            connect(m_pPackagesTree, &QITreeWidget::customContextMenuRequested,
+                    this, &UIGlobalSettingsExtension::sltHandleContextMenuRequest);
         }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsLanguage.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsLanguage.cpp	(revision 80668)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsLanguage.cpp	(revision 80669)
@@ -347,8 +347,8 @@
             m_pLanguageTree->hideColumn(3);
             m_pLanguageTree->setMinimumHeight(150);
-            connect(m_pLanguageTree, SIGNAL(painted(QTreeWidgetItem *, QPainter *)),
-                    this, SLOT(sltHandleItemPainting(QTreeWidgetItem *, QPainter *)));
-            connect(m_pLanguageTree, SIGNAL(currentItemChanged(QTreeWidgetItem *, QTreeWidgetItem *)),
-                    this, SLOT(sltHandleCurrentItemChange(QTreeWidgetItem *)));
+            connect(m_pLanguageTree, &QITreeWidget::painted,
+                    this, &UIGlobalSettingsLanguage::sltHandleItemPainting);
+            connect(m_pLanguageTree, &QITreeWidget::currentItemChanged,
+                    this, &UIGlobalSettingsLanguage::sltHandleCurrentItemChange);
         }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsNetwork.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsNetwork.cpp	(revision 80668)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsNetwork.cpp	(revision 80669)
@@ -559,12 +559,12 @@
 {
     /* Configure 'NAT Network' connections: */
-    connect(m_pTreeNetworkNAT, SIGNAL(currentItemChanged(QTreeWidgetItem *, QTreeWidgetItem *)),
-            this, SLOT(sltHandleCurrentItemChangeNATNetwork()));
-    connect(m_pTreeNetworkNAT, SIGNAL(customContextMenuRequested(const QPoint &)),
-            this, SLOT(sltHandleContextMenuRequestNATNetwork(const QPoint &)));
-    connect(m_pTreeNetworkNAT, SIGNAL(itemDoubleClicked(QTreeWidgetItem *, int)),
-            this, SLOT(sltEditNATNetwork()));
-    connect(m_pTreeNetworkNAT, SIGNAL(itemChanged(QTreeWidgetItem *, int)),
-            this, SLOT(sltHandleItemChangeNATNetwork(QTreeWidgetItem *)));
+    connect(m_pTreeNetworkNAT, &QITreeWidget::currentItemChanged,
+            this, &UIGlobalSettingsNetwork::sltHandleCurrentItemChangeNATNetwork);
+    connect(m_pTreeNetworkNAT, &QITreeWidget::customContextMenuRequested,
+            this, &UIGlobalSettingsNetwork::sltHandleContextMenuRequestNATNetwork);
+    connect(m_pTreeNetworkNAT, &QITreeWidget::itemDoubleClicked,
+            this, &UIGlobalSettingsNetwork::sltEditNATNetwork);
+    connect(m_pTreeNetworkNAT, &QITreeWidget::itemChanged,
+            this, &UIGlobalSettingsNetwork::sltHandleItemChangeNATNetwork);
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsPortForwardingDlg.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsPortForwardingDlg.cpp	(revision 80668)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsPortForwardingDlg.cpp	(revision 80669)
@@ -56,6 +56,6 @@
         {
             /* Configure button-box: */
-            connect(m_pButtonBox->button(QDialogButtonBox::Ok), SIGNAL(clicked()), this, SLOT(accept()));
-            connect(m_pButtonBox->button(QDialogButtonBox::Cancel), SIGNAL(clicked()), this, SLOT(reject()));
+            connect(m_pButtonBox->button(QDialogButtonBox::Ok), &QPushButton::clicked, this, &UIGlobalSettingsPortForwardingDlg::accept);
+            connect(m_pButtonBox->button(QDialogButtonBox::Cancel), &QPushButton::clicked, this, &UIGlobalSettingsPortForwardingDlg::reject);
         }
         /* Add widgets into layout: */
@@ -109,3 +109,2 @@
     m_pTabWidget->setTabText(1, tr("IPv6"));
 }
-
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsUpdate.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsUpdate.cpp	(revision 80668)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsUpdate.cpp	(revision 80669)
@@ -209,6 +209,7 @@
     {
         /* Configure widgets: */
-        connect(m_pCheckBoxUpdate, SIGNAL(toggled(bool)), this, SLOT(sltHandleUpdateToggle(bool)));
-        connect(m_pComboBoxUpdatePeriod, SIGNAL(activated(int)), this, SLOT(sltHandleUpdatePeriodChange()));
+        connect(m_pCheckBoxUpdate, &QCheckBox::toggled, this, &UIGlobalSettingsUpdate::sltHandleUpdateToggle);
+        connect(m_pComboBoxUpdatePeriod, static_cast<void(QComboBox::*)(int)>(&QComboBox::activated),
+                this, &UIGlobalSettingsUpdate::sltHandleUpdatePeriodChange);
     }
 
@@ -260,3 +261,2 @@
     return fSuccess;
 }
-