Index: /trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsSF.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsSF.cpp	(revision 80735)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsSF.cpp	(revision 80736)
@@ -445,5 +445,5 @@
 
     /* Connect header-resize signal just before widget is shown after all the items properly loaded and initialized: */
-    connect(mTwFolders->header(), SIGNAL(sectionResized(int, int, int)), this, SLOT(sltAdjustTreeFields()));
+    connect(mTwFolders->header(), &QHeaderView::sectionResized, this, &UIMachineSettingsSF::sltAdjustTreeFields);
 
     /* Adjusting size after all pending show events are processed: */
@@ -751,10 +751,10 @@
 {
     /* Configure tree-widget connections: */
-    connect(mTwFolders, SIGNAL(currentItemChanged(QTreeWidgetItem *, QTreeWidgetItem *)),
-            this, SLOT(sltHandleCurrentItemChange(QTreeWidgetItem *)));
-    connect(mTwFolders, SIGNAL(itemDoubleClicked(QTreeWidgetItem *, int)),
-            this, SLOT(sltHandleDoubleClick(QTreeWidgetItem *)));
-    connect(mTwFolders, SIGNAL(customContextMenuRequested(const QPoint &)),
-            this, SLOT(sltHandleContextMenuRequest(const QPoint &)));
+    connect(mTwFolders, &QITreeWidget::currentItemChanged,
+            this, &UIMachineSettingsSF::sltHandleCurrentItemChange);
+    connect(mTwFolders, &QITreeWidget::itemDoubleClicked,
+            this, &UIMachineSettingsSF::sltHandleDoubleClick);
+    connect(mTwFolders, &QITreeWidget::customContextMenuRequested,
+            this, &UIMachineSettingsSF::sltHandleContextMenuRequest);
 }
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsSerial.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsSerial.cpp	(revision 80735)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsSerial.cpp	(revision 80736)
@@ -167,10 +167,10 @@
 
     /* Setup connections: */
-    connect(mGbSerial, SIGNAL(toggled(bool)),
-            this, SLOT(sltGbSerialToggled(bool)));
-    connect(mCbNumber, SIGNAL(activated(const QString &)),
-            this, SLOT(sltCbNumberActivated(const QString &)));
-    connect(mCbMode, SIGNAL(activated(const QString &)),
-            this, SLOT(sltCbModeActivated(const QString &)));
+    connect(mGbSerial, &QCheckBox::toggled,
+            this, &UIMachineSettingsSerial::sltGbSerialToggled);
+    connect(mCbNumber, static_cast<void(QComboBox::*)(const QString&)>(&QComboBox::activated),
+            this, &UIMachineSettingsSerial::sltCbNumberActivated);
+    connect(mCbMode, static_cast<void(QComboBox::*)(const QString&)>(&QComboBox::activated),
+            this, &UIMachineSettingsSerial::sltCbModeActivated);
 
     /* Prepare validation: */
@@ -310,7 +310,7 @@
 {
     /* Prepare validation: */
-    connect(mLeIRQ, SIGNAL(textChanged(const QString&)), m_pParent, SLOT(revalidate()));
-    connect(mLeIOPort, SIGNAL(textChanged(const QString&)), m_pParent, SLOT(revalidate()));
-    connect(mLePath, SIGNAL(textChanged(const QString&)), m_pParent, SLOT(revalidate()));
+    connect(mLeIRQ, &QLineEdit::textChanged, m_pParent, &UIMachineSettingsSerialPage::revalidate);
+    connect(mLeIOPort, &QLineEdit::textChanged, m_pParent, &UIMachineSettingsSerialPage::revalidate);
+    connect(mLePath, &QLineEdit::textChanged, m_pParent, &UIMachineSettingsSerialPage::revalidate);
 }
 
@@ -687,3 +687,2 @@
 
 # include "UIMachineSettingsSerial.moc"
-
Index: /trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsStorage.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsStorage.cpp	(revision 80735)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsStorage.cpp	(revision 80736)
@@ -3168,5 +3168,5 @@
     if (pOpenMediumMenu)
     {
-        /* Eraze menu initially: */
+        /* Erase menu initially: */
         pOpenMediumMenu->clear();
         /* Depending on current medium type: */
@@ -3178,5 +3178,5 @@
                 QAction *pCreateNewHardDisk = pOpenMediumMenu->addAction(tr("Create New Hard Disk..."));
                 pCreateNewHardDisk->setIcon(iconPool()->icon(HDNewEn, HDNewDis));
-                connect(pCreateNewHardDisk, SIGNAL(triggered(bool)), this, SLOT(sltCreateNewHardDisk()));
+                connect(pCreateNewHardDisk, &QAction::triggered, this, &UIMachineSettingsStorage::sltCreateNewHardDisk);
                 /* Add "Choose a virtual hard disk" action: */
                 addChooseExistingMediumAction(pOpenMediumMenu, tr("Choose Virtual Hard Disk..."));
@@ -3198,5 +3198,5 @@
                 pEjectCurrentMedium->setEnabled(!m_pMediumIdHolder->isNull());
                 pEjectCurrentMedium->setIcon(iconPool()->icon(CDUnmountEnabled, CDUnmountDisabled));
-                connect(pEjectCurrentMedium, SIGNAL(triggered(bool)), this, SLOT(sltUnmountDevice()));
+                connect(pEjectCurrentMedium, &QAction::triggered, this, &UIMachineSettingsStorage::sltUnmountDevice);
                 break;
             }
@@ -3214,5 +3214,5 @@
                 pEjectCurrentMedium->setEnabled(!m_pMediumIdHolder->isNull());
                 pEjectCurrentMedium->setIcon(iconPool()->icon(FDUnmountEnabled, FDUnmountDisabled));
-                connect(pEjectCurrentMedium, SIGNAL(triggered(bool)), this, SLOT(sltUnmountDevice()));
+                connect(pEjectCurrentMedium, &QAction::triggered, this, &UIMachineSettingsStorage::sltUnmountDevice);
                 break;
             }
@@ -3968,24 +3968,24 @@
 {
     /* Configure this: */
-    connect(&uiCommon(), SIGNAL(sigMediumEnumerated(const QUuid &)),
-            this, SLOT(sltHandleMediumEnumerated(const QUuid &)));
-    connect(&uiCommon(), SIGNAL(sigMediumDeleted(const QUuid &)),
-            this, SLOT(sltHandleMediumDeleted(const QUuid &)));
+    connect(&uiCommon(), &UICommon::sigMediumEnumerated,
+            this, &UIMachineSettingsStorage::sltHandleMediumEnumerated);
+    connect(&uiCommon(), &UICommon::sigMediumDeleted,
+            this, &UIMachineSettingsStorage::sltHandleMediumDeleted);
 
     /* Configure tree-view: */
-    connect(m_pTreeStorage, SIGNAL(currentItemChanged(const QModelIndex &, const QModelIndex &)),
-             this, SLOT(sltHandleCurrentItemChange()));
-    connect(m_pTreeStorage, SIGNAL(customContextMenuRequested(const QPoint &)),
-             this, SLOT(sltHandleContextMenuRequest(const QPoint &)));
-    connect(m_pTreeStorage, SIGNAL(drawItemBranches(QPainter *, const QRect &, const QModelIndex &)),
-             this, SLOT(sltHandleDrawItemBranches(QPainter *, const QRect &, const QModelIndex &)));
-    connect(m_pTreeStorage, SIGNAL(mouseMoved(QMouseEvent *)),
-             this, SLOT(sltHandleMouseMove(QMouseEvent *)));
+    connect(m_pTreeStorage, &QITreeView::currentItemChanged,
+             this, &UIMachineSettingsStorage::sltHandleCurrentItemChange);
+    connect(m_pTreeStorage, &QITreeView::customContextMenuRequested,
+            this, &UIMachineSettingsStorage::sltHandleContextMenuRequest);
+    connect(m_pTreeStorage, &QITreeView::drawItemBranches,
+            this, &UIMachineSettingsStorage::sltHandleDrawItemBranches);
+    connect(m_pTreeStorage, &QITreeView::mouseMoved,
+            this, &UIMachineSettingsStorage::sltHandleMouseMove);
     connect(m_pTreeStorage, &QITreeView::mousePressed,
             this, &UIMachineSettingsStorage::sltHandleMouseClick);
     connect(m_pTreeStorage, &QITreeView::mouseReleased,
             this, &UIMachineSettingsStorage::sltHandleMouseRelease);
-    connect(m_pTreeStorage, SIGNAL(mouseDoubleClicked(QMouseEvent *)),
-             this, SLOT(sltHandleMouseClick(QMouseEvent *)));
+    connect(m_pTreeStorage, &QITreeView::mouseDoubleClicked,
+            this, &UIMachineSettingsStorage::sltHandleMouseClick);
     connect(m_pTreeStorage, &QITreeView::dragEntered,
             this, &UIMachineSettingsStorage::sltHandleDragEnter);
@@ -3996,43 +3996,54 @@
 
     /* Create model: */
-    connect(m_pModelStorage, SIGNAL(rowsInserted(const QModelIndex &, int, int)),
-            this, SLOT(sltHandleRowInsertion(const QModelIndex &, int)));
-    connect(m_pModelStorage, SIGNAL(rowsRemoved(const QModelIndex&, int, int)),
-            this, SLOT(sltHandleRowRemoval()));
+    connect(m_pModelStorage, &StorageModel::rowsInserted,
+            this, &UIMachineSettingsStorage::sltHandleRowInsertion);
+    connect(m_pModelStorage, &StorageModel::rowsRemoved,
+            this, &UIMachineSettingsStorage::sltHandleRowRemoval);
 
     /* Configure actions: */
-    connect(m_pActionAddController, SIGNAL(triggered(bool)), this, SLOT(sltAddController()));
-    connect(m_pActionAddControllerIDE, SIGNAL(triggered(bool)), this, SLOT(sltAddControllerIDE()));
-    connect(m_pActionAddControllerSATA, SIGNAL(triggered(bool)), this, SLOT(sltAddControllerSATA()));
-    connect(m_pActionAddControllerSCSI, SIGNAL(triggered(bool)), this, SLOT(sltAddControllerSCSI()));
-    connect(m_pActionAddControllerFloppy, SIGNAL(triggered(bool)), this, SLOT(sltAddControllerFloppy()));
-    connect(m_pActionAddControllerSAS, SIGNAL(triggered(bool)), this, SLOT(sltAddControllerSAS()));
-    connect(m_pActionAddControllerUSB, SIGNAL(triggered(bool)), this, SLOT(sltAddControllerUSB()));
-    connect(m_pActionAddControllerNVMe, SIGNAL(triggered(bool)), this, SLOT(sltAddControllerNVMe()));
-    connect(m_pActionAddControllerVirtioSCSI, SIGNAL(triggered(bool)), this, SLOT(sltAddControllerVirtioSCSI()));
-    connect(m_pActionRemoveController, SIGNAL(triggered(bool)), this, SLOT(sltRemoveController()));
-    connect(m_pActionAddAttachment, SIGNAL(triggered(bool)), this, SLOT(sltAddAttachment()));
-    connect(m_pActionAddAttachmentHD, SIGNAL(triggered(bool)), this, SLOT(sltAddAttachmentHD()));
-    connect(m_pActionAddAttachmentCD, SIGNAL(triggered(bool)), this, SLOT(sltAddAttachmentCD()));
-    connect(m_pActionAddAttachmentFD, SIGNAL(triggered(bool)), this, SLOT(sltAddAttachmentFD()));
-    connect(m_pActionRemoveAttachment, SIGNAL(triggered(bool)), this, SLOT(sltRemoveAttachment()));
+    connect(m_pActionAddController, &QAction::triggered, this, &UIMachineSettingsStorage::sltAddController);
+    connect(m_pActionAddControllerIDE, &QAction::triggered, this, &UIMachineSettingsStorage::sltAddControllerIDE);
+    connect(m_pActionAddControllerSATA, &QAction::triggered, this, &UIMachineSettingsStorage::sltAddControllerSATA);
+    connect(m_pActionAddControllerSCSI, &QAction::triggered, this, &UIMachineSettingsStorage::sltAddControllerSCSI);
+    connect(m_pActionAddControllerFloppy, &QAction::triggered, this, &UIMachineSettingsStorage::sltAddControllerFloppy);
+    connect(m_pActionAddControllerSAS, &QAction::triggered, this, &UIMachineSettingsStorage::sltAddControllerSAS);
+    connect(m_pActionAddControllerUSB, &QAction::triggered, this, &UIMachineSettingsStorage::sltAddControllerUSB);
+    connect(m_pActionAddControllerNVMe, &QAction::triggered, this, &UIMachineSettingsStorage::sltAddControllerNVMe);
+    connect(m_pActionAddControllerVirtioSCSI, &QAction::triggered, this, &UIMachineSettingsStorage::sltAddControllerVirtioSCSI);
+    connect(m_pActionRemoveController, &QAction::triggered, this, &UIMachineSettingsStorage::sltRemoveController);
+    connect(m_pActionAddAttachment, &QAction::triggered, this, &UIMachineSettingsStorage::sltAddAttachment);
+    connect(m_pActionAddAttachmentHD, &QAction::triggered, this, &UIMachineSettingsStorage::sltAddAttachmentHD);
+    connect(m_pActionAddAttachmentCD, &QAction::triggered, this, &UIMachineSettingsStorage::sltAddAttachmentCD);
+    connect(m_pActionAddAttachmentFD, &QAction::triggered, this, &UIMachineSettingsStorage::sltAddAttachmentFD);
+    connect(m_pActionRemoveAttachment, &QAction::triggered, this, &UIMachineSettingsStorage::sltRemoveAttachment);
 
     /* Configure tool-button: */
-    connect(mTbOpen, SIGNAL(clicked(bool)), mTbOpen, SLOT(showMenu()));
+    connect(mTbOpen, &QIToolButton::clicked, mTbOpen, &QIToolButton::showMenu);
     /* Configure menu: */
-    connect(mTbOpen->menu(), SIGNAL(aboutToShow()), this, SLOT(sltPrepareOpenMediumMenu()));
+    connect(mTbOpen->menu(), &QMenu::aboutToShow, this, &UIMachineSettingsStorage::sltPrepareOpenMediumMenu);
 
     /* Configure widgets: */
-    connect(m_pMediumIdHolder, SIGNAL(sigChanged()), this, SLOT(sltSetInformation()));
-    connect(mSbPortCount, SIGNAL(valueChanged(int)), this, SLOT(sltSetInformation()));
-    connect(mLeName, SIGNAL(textEdited(const QString &)), this, SLOT(sltSetInformation()));
-    connect(mCbBus, SIGNAL(activated(int)), this, SLOT(sltSetInformation()));
-    connect(mCbType, SIGNAL(activated(int)), this, SLOT(sltSetInformation()));
-    connect(mCbSlot, SIGNAL(activated(int)), this, SLOT(sltSetInformation()));
-    connect(mCbIoCache, SIGNAL(stateChanged(int)), this, SLOT(sltSetInformation()));
-    connect(mCbPassthrough, SIGNAL(stateChanged(int)), this, SLOT(sltSetInformation()));
-    connect(mCbTempEject, SIGNAL(stateChanged(int)), this, SLOT(sltSetInformation()));
-    connect(mCbNonRotational, SIGNAL(stateChanged(int)), this, SLOT(sltSetInformation()));
-    connect(m_pCheckBoxHotPluggable, SIGNAL(stateChanged(int)), this, SLOT(sltSetInformation()));
+    connect(m_pMediumIdHolder, &UIMediumIDHolder::sigChanged,
+            this, &UIMachineSettingsStorage::sltSetInformation);
+    connect(mSbPortCount, static_cast<void(QSpinBox::*)(int)>(&QSpinBox::valueChanged),
+            this, &UIMachineSettingsStorage::sltSetInformation);
+    connect(mLeName, &QLineEdit::textEdited,
+            this, &UIMachineSettingsStorage::sltSetInformation);
+    connect(mCbBus, static_cast<void(QComboBox::*)(int)>(&QComboBox::activated),
+            this, &UIMachineSettingsStorage::sltSetInformation);
+    connect(mCbType, static_cast<void(QComboBox::*)(int)>(&QComboBox::activated),
+            this, &UIMachineSettingsStorage::sltSetInformation);
+    connect(mCbSlot, static_cast<void(QComboBox::*)(int)>(&QComboBox::activated),
+            this, &UIMachineSettingsStorage::sltSetInformation);
+    connect(mCbIoCache, &QCheckBox::stateChanged,
+            this, &UIMachineSettingsStorage::sltSetInformation);
+    connect(mCbPassthrough, &QCheckBox::stateChanged,
+            this, &UIMachineSettingsStorage::sltSetInformation);
+    connect(mCbTempEject, &QCheckBox::stateChanged,
+            this, &UIMachineSettingsStorage::sltSetInformation);
+    connect(mCbNonRotational, &QCheckBox::stateChanged,
+            this, &UIMachineSettingsStorage::sltSetInformation);
+    connect(m_pCheckBoxHotPluggable, &QCheckBox::stateChanged,
+            this, &UIMachineSettingsStorage::sltSetInformation);
 }
 
@@ -4185,5 +4196,5 @@
     QAction *pChooseExistingMedium = pOpenMediumMenu->addAction(strActionName);
     pChooseExistingMedium->setIcon(iconPool()->icon(ChooseExistingEn, ChooseExistingDis));
-    connect(pChooseExistingMedium, SIGNAL(triggered(bool)), this, SLOT(sltChooseExistingMedium()));
+    connect(pChooseExistingMedium, &QAction::triggered, this, &UIMachineSettingsStorage::sltChooseExistingMedium);
 }
 
@@ -4197,5 +4208,5 @@
             QAction *pHostDriveAction = pOpenMediumMenu->addAction(medium.name());
             pHostDriveAction->setData(medium.id());
-            connect(pHostDriveAction, SIGNAL(triggered(bool)), this, SLOT(sltChooseHostDrive()));
+            connect(pHostDriveAction, &QAction::triggered, this, &UIMachineSettingsStorage::sltChooseHostDrive);
         }
     }